<%--
* Licensed Materials - Property of IBM
* 
* 5724-U18
* 
* (C) COPYRIGHT IBM CORP. 2006,2014 All Rights Reserved.
* 
* US Government Users Restricted Rights - Use, duplication or
* disclosure restricted by GSA ADP Schedule Contract with
* IBM Corp.
--%>
<%@ page contentType="text/html;charset=UTF-8" session="true" import="java.util.Vector,java.util.*,psdi.webclient.system.runtime.WebClientRuntime,
 psdi.webclient.system.runtime.WebClientConstants,psdi.util.MXSession,psdi.server.MXServer,java.util.StringTokenizer,
 com.ibm.tivoli.maximo.report.birt.logging.ReportLogger,com.ibm.tivoli.maximo.report.birt.logging.ReportLoggerFactory,
 psdi.util.logging.MXLoggerFactory,psdi.util.logging.MXLogger,psdi.app.report.ReportUtil"%>
<%
    MXLogger myLogger = MXLoggerFactory.getLogger("maximo.report.directprint");
	response.setHeader("Cache-Control","no-cache"); //HTTP 1.1
	response.setHeader("Pragma","no-cache"); //HTTP 1.0
	response.setDateHeader ("Expires", 0); // Proxy request
	MXSession mxsession= (MXSession)request.getSession().getAttribute("MXSession");
	if (!mxsession.isConnected())
	{
	       	//Do something which will show error on the page like redirect to login
	       	String url = WebClientRuntime.getMaximoRequestContextURL(request)+"/ui/login";
	       	response.sendRedirect(url);
			return;
	}
	String ibmdirectprintkey=(String) request.getParameter("ibmdirectprintkey");
	myLogger.debug("printjobspooler.jsp  ibmdirectprintkey="+ibmdirectprintkey+" SessionId="+request.getSession().getId());
	if(ibmdirectprintkey==null)
	{
		ibmdirectprintkey="";
	}
	else
	{
		if (!ReportUtil.validateDPKey(ibmdirectprintkey))
		{
			String errmsg="The format of the ibmdirectprintkey parameter is invalid: " + ibmdirectprintkey;
			myLogger.error(errmsg);
			String replyMsg="Invalid request.  Ask your system administrator to check the logs for details.";
			response.getWriter().write(replyMsg);
			return;
		}
	}
	String doclinkSessionParam=	"doclinks"+ibmdirectprintkey;
	Vector printabledocs = (Vector)session.getAttribute("doclinks"+ibmdirectprintkey);
	myLogger.debug("printjobspooler.jsp printabledocs"+printabledocs+" SessionId="+request.getSession().getId());
	Hashtable msDocs = new Hashtable();
	String message  = (String)session.getAttribute("printmessage"+ibmdirectprintkey);
	String errmessage  = (String)session.getAttribute("printerrmsg"+ibmdirectprintkey);
	String rptype  = (String)session.getAttribute("reportprinttype"+ibmdirectprintkey);
	String twopasspdf  = (String)session.getAttribute("twopasspdf"+ibmdirectprintkey);
	String printdebug  = (String)session.getAttribute("printdebug"+ibmdirectprintkey);
	String printwait = (String)session.getAttribute("printwait"+ibmdirectprintkey);
	String securedattachment= (String)session.getAttribute("securedattachment"+ibmdirectprintkey);
	String waitAfterMsDoc = (String)session.getAttribute("waitAfterMsDoc"+ibmdirectprintkey);
	//String baseurl=(String)session.getAttribute("baseurl");
	String baseUrl=(String) request.getParameter("baseUrl");
	if(baseUrl==null)
		baseUrl="";
		else
	{
	
		String baseUrlDefault=WebClientRuntime.getMaximoBaseURL(request);
		if(!baseUrl.equalsIgnoreCase(baseUrlDefault))
		{
			String baseUrlNoPort=baseUrl.replace(":80","");
			baseUrlNoPort=baseUrlNoPort.replace(":443","");
			if(!baseUrlNoPort.equalsIgnoreCase(baseUrlDefault))
			{
				boolean needBaseUrls=false;
				String baseUrls=MXServer.getMXServer().getProperty("mxe.report.birt.proxyurlredirect");
				if(baseUrls==null || baseUrls.isEmpty())
					needBaseUrls=true;
				else
				{
					boolean foundMatch=false;
					StringTokenizer st=new StringTokenizer(baseUrls,",");
					while(st.hasMoreTokens())
					{
						String nextUrl=st.nextToken().trim();
						if(baseUrl.equalsIgnoreCase(nextUrl))
						{
							foundMatch=true;
							break;
						}
					}
					if(!foundMatch)
						needBaseUrls=true;
				}
				if(needBaseUrls)
				{
					ReportLogger reportLogger = ReportLoggerFactory.getLogger("maximo.report.birt");
					String errmsg="A proxy server has been detected which modifies the url. "+  
							"Contact the system administrator to add "+baseUrl+" to the property mxe.report.birt.proxyurlredirect. "+
							"You can have multiple values separated by commas.";
					reportLogger.error(errmsg);
					String replyMsg="A proxy server has been detected which modifies the url. "+  
							"Contact the system administrator to set the property mxe.report.birt.proxyurlredirect. "+
    						"The server log will have the exact value to be set to this property. Check for an entry around the time this error was received.";
					response.getWriter().write(replyMsg);
					return;
				}
			}
		}

	}	
	String tokenurlPart= (String)session.getAttribute("tokenurlPart"+ibmdirectprintkey);
	String tokenurl= baseUrl+request.getContextPath()+tokenurlPart;
	//session.removeAttribute("doclinks");
	//session.removeAttribute("printmessage"+ibmdirectprintkey);
	//session.removeAttribute("reporttype"+ibmdirectprintkey);
	//session.removeAttribute("printerrmsg"+ibmdirectprintkey);
	//session.removeAttribute("twopasspdf"+ibmdirectprintkey);
	//session.removeAttribute("printdebug"+ibmdirectprintkey);
	//session.removeAttribute("printwait"+ibmdirectprintkey);
	//session.removeAttribute("securedattachment"+ibmdirectprintkey);
	//session.removeAttribute("waitAfterMsDoc"+ibmdirectprintkey);
	String appletBase = "../applets";
	boolean activeXDocs = false;
	int noOfIframes=5;
	//System.out.println ("File Size "+ printabledocs.size()); 
	String maximourl = "";
    	String proxyHost = WebClientRuntime.getWebClientProperty("proxy_hostname");
    	String proxyPort = WebClientRuntime.getWebClientProperty("proxy_port");
    	if (proxyHost != null && ! proxyHost.trim().equals("") ) 
    	{  	  	
    		if (proxyPort != null) 
    		{
    			if (proxyPort.trim().equals("443") || proxyPort.trim().equals("80")|| proxyPort.trim().equals(""))
    				proxyPort = "";
    			else 
    				proxyPort = ":"+proxyPort;
    		}

    		maximourl = request.getScheme()+"://"+proxyHost.trim()+proxyPort.trim();   	

    	}  			
	//System.out.println ("URL "+ maximourl); 
	int paramCount = printabledocs.size();
%>

<html>

<BODY>
<!--
USE SIGNED VERSIONS OF JAR FILES IF NEEDED
JARS ARE IN maximouiweb\webmodule\webclient\applets\quickprint
ALSO CHANGE THE JAR NAMES BELOW (ARCHIVE and CODE) TO THE SIGNED JAR FILE NAMES
-->
<img src="../images/printprogressbar.gif" alt=""/>
<br>
<b><%=message%></b>
<br><br><br><br><br><br><br><br>

<SCRIPT>
var msword ;
var msexcel ;
var msppt ;
<% 
if (rptype != null && rptype.equals("PAD")) {
%>
function printMSObjects(docnum,token)
{
	self.focus();
<%	
	for (int iLoop=0;iLoop < paramCount;iLoop++)
	{ 
		String doc2 = (String)printabledocs.elementAt(iLoop);
		if (doc2.startsWith("\\\\")) { 
			doc2 = "file:"+doc2.replaceAll("\\\\", "/");	
			doc2 = doc2.replace("//", "/");			
		}
		/* else if (! doc2.startsWith("http"))
		{
		   doc2 = baseUrl + doc2;	
		}
		*/
		if(doc2.toUpperCase().startsWith("FILE") && (doc2.toUpperCase().endsWith(".XLS") || doc2.toUpperCase().endsWith(".XLSX")))
		{
			doc2 = doc2.replace("file://///", "//");
			doc2 = doc2.replace("file://", "//");
		}		
		if(doc2.toUpperCase().endsWith("DOC") 
		|| doc2.toUpperCase().endsWith("XLS")
		|| doc2.toUpperCase().endsWith("PPT")
		|| doc2.toUpperCase().endsWith("DOCX")
		|| doc2.toUpperCase().endsWith("XLSX")
		|| doc2.toUpperCase().endsWith("PPTX")				
		)
		{	
		   String printFunc = "printDOC"; //Default word document
		   if (doc2.toUpperCase().endsWith("XLS") || doc2.toUpperCase().endsWith("XLSX") )  printFunc = "printXLS";
		   if (doc2.toUpperCase().endsWith("PPT") || doc2.toUpperCase().endsWith("PPTX") )  printFunc = "printPPT";
%>
			if (docnum == <%=iLoop%>)
			{
				<%=printFunc%>("<%=doc2%>"+token);
			}
<%
		}
	}
	msDocs.clear();
%>
}
// ADDED TO REPLACE POWERTEAM ACTIVEX FOR MS DOCS ISSUE 10-10685
function printDOC(inDoc) {
	if (msword==null) {
		msword=new ActiveXObject('Word.Application');
		msword.Visible = false;
	}
	if (msword != null)
	{
		var doc = msword.Documents.Open(inDoc,false,true);
		doc.PrintOut();
		doc.Close(0);
	}
}


function printPPT(inPpt) {
	if (msppt==null) {
		msppt=new ActiveXObject('Powerpoint.Application');
	}
	if (msppt != null)
	{
		var doc = msppt.Presentations.Open(inPpt,false,false,false);
		doc.PrintOut();
		doc.Close(0);
	}
}


function printXLS(inXls) {
	if (msexcel==null) {
		msexcel=new ActiveXObject('Excel.Application');
		msexcel.Visible = false;
	}
	if (msexcel != null)
	{
		var doc = msexcel.Workbooks.Open(inXls,false,true);
		doc.PrintOut();
		doc.Close(0);
	}
}

<% 
} // endifactivex
%>

<!-- PRINT PDF BY USING ACROBAT READER -->

<%	
	for (int pdfLoop=1;pdfLoop <= noOfIframes;pdfLoop++)
	{ 
	%>
function printPDF<%=pdfLoop%>(inPDFDoc)
{	
	index1 = inPDFDoc.indexOf("/secureprovider?file=")
	if(index1>0)
	{ 
		firstPart=inPDFDoc.substring(0,index1+21);
		index2=inPDFDoc.indexOf("&uisessionid=");
		toChange=inPDFDoc.substring(index1+21,index2);
		lastPart=inPDFDoc.substring(index2);
		toChange=myReplaceAll(toChange,'/n','%0A');
		toChange=myReplaceAll(toChange,'/r','%0D');
		inPDFDoc=firstPart+toChange+lastPart;
	}
	document.getElementById('pdfRender<%=pdfLoop%>').src=inPDFDoc;
}
<%
	}
%>


<!--CLOSE BROWSER FUNCTION-->	
function closeWindow()
{
	if (msword !=null) msword.Quit();
	if (msexcel !=null) msexcel.Quit();
	if (msppt !=null) msppt.Quit();
	self.close();
}
<!--CLOSE BROWSER FUNCTION-->
function showErrorMessage()
{
	if (msword !=null) msword.Quit();
	if (msexcel !=null) msexcel.Quit();
	if (msppt !=null) msppt.Quit();
	alert("<%=errmessage%>");
	self.close();
}

function invokeUrl(url) {	
	try
	{
		if (window.XMLHttpRequest)
		{
			// code for most browsers except older IE
			xmlHttp = new XMLHttpRequest();
		}
		else
		{
			// code for Older IE
			xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
		}
		xmlHttp.onreadystatechange = ProcessRequest;
		xmlHttp.open( "GET", url, true );
		xmlHttp.send( null );
	}
	catch(err)
	{
		alert('printNextDocument Error:'+err.message);
		alert('StackTrace'+err.stack);		
	}
}


function ProcessRequest() 
{
    if ( xmlHttp.readyState == 4) 
    {
		var silentPrintApplet = document.getElementById("SilentPrint");
	    if(xmlHttp.status == 200)
		{
			
			try 
			{
				silentPrintApplet.onJavascriptResponse(xmlHttp.responseText);
			} 
			catch (e) 
			{
				alert('Error while setting the response:', e.message);
			}
        }
        else
        {

			try 
			{
				silentPrintApplet.onJavascriptResponse(null);
			} 
			catch (e) 
			{
				alert('Error while setting the null response:', e.message);
			}
        }                    
    }
}

function myReplaceAll(oldStr, toBeReplaced, replaceStr)
{      
    newStr=oldStr;
    while (true)
	{ 
		if(newStr.indexOf(toBeReplaced) == -1)
			break;
		newStr=newStr.replace(toBeReplaced, replaceStr);
	}
	 return newStr; 
} 

</SCRIPT>

<!--[if !IE]>-->
<OBJECT classid="java:com.ibm.tivoli.maximo.report.applet.quickprint.SilentPrint.class"
		type="<%= WebClientRuntime.getWebClientProperty("mxe.javaApplet.Type", WebClientConstants.JAVA_APPLET_OBJECT_TYPE) %>"
		height="0"
		width="0"
		id="SilentPrint">
    	<PARAM NAME="mayscript" VALUE="true">
		<PARAM NAME="scriptable" VALUE="true">
        <PARAM NAME="type" VALUE="<%= WebClientRuntime.getWebClientProperty("mxe.javaApplet.Type", WebClientConstants.JAVA_APPLET_OBJECT_TYPE) %>">
        <PARAM NAME="name" VALUE="Maximo DirectPrint">
        <PARAM NAME="alt" VALUE="Maximo DirectPrint">
        <PARAM NAME="ARCHIVE" VALUE="<%=appletBase%>/QuickPrint.jar">
        <PARAM NAME="cache_option" VALUE="Plugin">
	    <PARAM NAME="reporttype" VALUE="<%=rptype%>">  
        <PARAM NAME="dummyPrint" VALUE="false">
        <PARAM NAME="printdebug" VALUE="<%=printdebug%>">
        <PARAM NAME="printwait" VALUE="<%=printwait%>">
        <PARAM NAME="twopasspdf" VALUE="<%=twopasspdf%>">  
		<PARAM NAME="noOfIframes" VALUE="<%=noOfIframes%>">  
		<PARAM NAME="securedattachment" value="<%=securedattachment%>">
		<PARAM NAME="tokenurl" value="<%=tokenurl%>">
		<PARAM NAME="waitAfterMsDoc" value="<%=waitAfterMsDoc%>">
<PARAM NAME="doclinkSessionParam" value="<%=doclinkSessionParam%>">
    <%	
	int docCount = -1;
	for (int i=0;i < paramCount;i++)
	{ 
		String tokenNeeded="";
		String doc = (String)printabledocs.elementAt(i);
		if(doc.indexOf("/reportattacheddocsservlet?") > -1)
			tokenNeeded="_tokenNeeded";
		/* following code is not used. It might hurt in some cases.
		if (doc.startsWith("\\\\")) 
		{
			doc = "file:"+doc.replaceAll("\\\\", "/");	
			doc = doc.replace("//", "/");	
		} else if (! doc.startsWith("http"))
		{
		   doc = baseUrl + doc;	
		}
		*/
		if(!(doc.toUpperCase().endsWith(".DOC") 
		|| doc.toUpperCase().endsWith(".XLS")
		|| doc.toUpperCase().endsWith(".PPT")
		|| doc.toUpperCase().endsWith(".DOCX")
		|| doc.toUpperCase().endsWith(".XLSX")
		|| doc.toUpperCase().endsWith(".PPTX")
		))
		{
			docCount += 1;
			if (doc.toUpperCase().indexOf(".PDF") > -1) 
			{
			   if (twopasspdf.equals("1")) 
			   {
			      if(doc.indexOf("/servlet/secureprovider") < 0)
						doc =request.getContextPath()+"/reportattacheddocsservlet?doaction=3&url="+doc;
			   } else {
					if(doc.indexOf("/servlet/secureprovider") < 0 )
				        doc =request.getContextPath()+"/servlet/SilentPrintServlet?doaction=1&url="+doc;
			   }
			}
			//System.out.println("File "+ doc);			
	%>
	<PARAM NAME="param_docfile_<%=i%>" VALUE="<%=doc%>">	
	<%
		} else if (rptype != null && rptype.equals("PAD")) {
			activeXDocs = true;
	%>
	<PARAM NAME="param_docfile_<%=i%>" VALUE="printMSObjects(<%=i%>)<%=tokenNeeded%>">
    <PARAM NAME="param_docfile_<%=i%>_url" VALUE="<%=doc%>">	
	<%		
		}
	}
    %>

<!--<![endif]-->
<OBJECT 
	CLASS="SilentPrint"
	id="SilentPrint"
	NAME="SilentPrint"
	mxpart="applet"
	codeBase="<%=appletBase%>"
    	width="0" height="0"
    	classid="clsid:<%= WebClientRuntime.getWebClientProperty("mxe.javaApplet.ClassidNoMinimum", WebClientConstants.JAVA_APPLET_OBJECT_CLASSID_GUID_NO_MINIMUM) %>">
    	<PARAM NAME="mayscript" VALUE="true">
		<PARAM NAME="scriptable" VALUE="true">
        <PARAM NAME="type" VALUE="<%= WebClientRuntime.getWebClientProperty("mxe.javaApplet.Type", WebClientConstants.JAVA_APPLET_OBJECT_TYPE) %>">
        <PARAM NAME="name" VALUE="Maximo DirectPrint">
        <PARAM NAME="alt" VALUE="Maximo DirectPrint">
        <PARAM NAME="CODE" VALUE="com.ibm.tivoli.maximo.report.applet.quickprint.SilentPrint">
        <PARAM NAME="ARCHIVE" VALUE="<%=appletBase%>/QuickPrint.jar">
        <PARAM NAME="cache_option" VALUE="Plugin">
	    <PARAM NAME="reporttype" VALUE="<%=rptype%>">  
        <PARAM NAME="dummyPrint" VALUE="false">
        <PARAM NAME="printdebug" VALUE="<%=printdebug%>">
        <PARAM NAME="printwait" VALUE="<%=printwait%>">
        <PARAM NAME="twopasspdf" VALUE="<%=twopasspdf%>"> 
        <PARAM NAME="noOfIframes" VALUE="<%=noOfIframes%>">	
		<PARAM NAME="securedattachment" value="<%=securedattachment%>">
		<PARAM NAME="tokenurl" value="<%=tokenurl%>">
		<PARAM NAME="waitAfterMsDoc" value="<%=waitAfterMsDoc%>">
		<PARAM NAME="doclinkSessionParam" value="<%=doclinkSessionParam%>">
    <%	

	docCount = -1;
	for (int i=0;i < paramCount;i++)
	{ 
		String tokenNeeded="";
		String doc = (String)printabledocs.elementAt(i);
		if(doc.indexOf("/reportattacheddocsservlet?") > -1)
			tokenNeeded="_tokenNeeded";
		/* following code is not used. It might hurt in some cases.
		if (doc.startsWith("\\\\")) 
		{
			doc = "file:"+doc.replaceAll("\\\\", "/");	
			doc = doc.replace("//", "/");	
		} else if (! doc.startsWith("http"))
		{
		   doc = baseUrl + doc;	
		}
        */		
		if(!(doc.toUpperCase().endsWith(".DOC") 
		|| doc.toUpperCase().endsWith(".XLS")
		|| doc.toUpperCase().endsWith(".PPT")
		|| doc.toUpperCase().endsWith(".DOCX")
		|| doc.toUpperCase().endsWith(".XLSX")
		|| doc.toUpperCase().endsWith(".PPTX")		
		))
		{
			docCount += 1;
			if (doc.toUpperCase().indexOf(".PDF") > -1) 
			{
			   if (twopasspdf.equals("1")) 
			   {
			      if(doc.indexOf("/servlet/secureprovider") < 0)
						doc =request.getContextPath()+"/reportattacheddocsservlet?doaction=3&url="+doc;
			   } else {
					if(doc.indexOf("/servlet/secureprovider") < 0 )
				        doc =request.getContextPath()+"/servlet/SilentPrintServlet?doaction=1&url="+doc;
			   }
			}
			//System.out.println("File "+ doc);						
	%>
	<PARAM NAME="param_docfile_<%=i%>" VALUE="<%=doc%>">	
	<%
		} else if (rptype != null && rptype.equals("PAD")) {
			activeXDocs = true;
	%>
	<PARAM NAME="param_docfile_<%=i%>" VALUE="printMSObjects(<%=i%>)<%=tokenNeeded%>">
	<PARAM NAME="param_docfile_<%=i%>_url" VALUE="<%=doc%>">	
	<%		
		}
	}
    %>
</OBJECT>
<!--[if !IE]>-->
</OBJECT>
<!--<![endif]-->
   <%
	for (int il=0;il < paramCount;il++)
	{ 
		String doc1 = (String)printabledocs.elementAt(il);
		if (doc1.startsWith("\\\\")) 
		{
			doc1 = "file:"+doc1.replaceAll("\\\\", "/");	
			doc1 = doc1.replace("//", "/");	
		}
		/* else if (! doc1.startsWith("http"))
		{
				   doc1 = baseUrl + doc1;	
		}
		*/			
		if(activeXDocs && (doc1.toUpperCase().endsWith("DOC") 
		|| doc1.toUpperCase().endsWith("XLS")
		|| doc1.toUpperCase().endsWith("PPT")
		|| doc1.toUpperCase().endsWith("DOCX")
		|| doc1.toUpperCase().endsWith("XLSX")
		|| doc1.toUpperCase().endsWith("PPTX")		
		) && (!msDocs.containsKey(doc1)))
		{
			msDocs.put(doc1,Integer.toString(il));		
		}
	}
    %>	
<!--Use to render and invoke adobe reader to print PDF -->    

<%	
	for (int pdfLoop=1;pdfLoop <= noOfIframes;pdfLoop++)
	{ 
	%>
<IFRAME id="pdfRender<%=pdfLoop%>" name="pdfRender<%=pdfLoop%>" width=350 height=340 src="">
</IFRAME>
<%
	}
%>


</BODY>
<% 
if (activeXDocs) {
%>
<!--Use of ACTIVEX to print microsoft documents-->
<% 
} // endifactivex
%>




</html>