/* IBM Confidential
 *
 * OCO Source Materials
 *
 * 5724-U18
 *
 * (C) COPYRIGHT IBM CORP. 2012,2017
 *
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */
require({
	packages : [
	            { name: "esri", location: window.URL_ESRI}
	   		]
	   	  }, [
                   "dojo/_base/declare", "dojo/parser", "dojo/ready", "dojo/query", "dijit/Tooltip",
                   "dijit/_WidgetBase", "esri/layers/ImageParameters", "esri/layers/ArcGISDynamicMapServiceLayer","esri/layers/FeatureLayer",
                   "esri/layers/ArcGISTiledMapServiceLayer", "esri/layers/ArcGISImageServiceLayer", "esri/layers/GraphicsLayer",
                   "esri/layers/ImageServiceParameters", "esri/dijit/Scalebar",
                   "esri/dijit/OverviewMap","ibm/tivoli/fwm/mxmap/security/ValidateUrlToken","dojo/dom-construct",
                   "esri/request", "dojo/promise/all",  "dojo/_base/lang", "ibm/tivoli/fwm/mxmap/linear/Linear",
                   "dojo/_base/array", "dojo/dom-attr", "dojo/aspect"
                   ], function(declare, parser, ready, query, Tooltip, _WidgetBase,
                		   ImageParameters, ArcGISDynamicMapServiceLayer, FeatureLayer, ArcGISTiledMapServiceLayer,
                		   ArcGISImageServiceLayer, GraphicsLayer, ImageServiceParameters, Scalebar,
                		   OverviewMap, ValidateUrlToken, domConstruct ,esriRequest, all, lang, Linear, arrayUtils, 
                		   domAttr, aspect){

	declare("ibm.tivoli.fwm.mxmap.impl.MaximoSpatialMxn", null, {

		map: null,
		mapConfig: null,
		fullExtent: null,
		mapstraction: null,
		maximoIntegration: null,
		numberOfExternalMaps: 0,
		totalLoaded: 0,
		totalMapServices: 0,
		loadList: [],
		mapInitialExtent: null,
		bingMapsLayer: null,
		osmTries: 0,
		spatialConf: null,
		validateURL: null,
		allLoaded: null,
		linear: null,
		linearOnMouseOverEvents: null,
		linearOnMouseOutEvents: null,
		constructor: function(options)
		{
			dojo.mixin(this, options);
			this.loadList = [];
			fromWebMercatorCache = {};
			toWebMercatorCache = {};
			this.allLoaded = null;
			this.validateURL = new ibm.tivoli.fwm.mxmap.security.ValidateUrlToken(this);
			this.linear = new ibm.tivoli.fwm.mxmap.linear.Linear({map: this.map});
			this.linearOnMouseOverEvents = [];
			this.linearOnMouseOutEvents = [];
		},
		/**
		 * This method checks if all layers are already loaded so further map
		 * operations can be performed
		 */
		checkIfAllLoaded: function(layersLoaded, layersIds)
		{
			if (this.allLoaded == true) {
				return;
			}
			if (layersLoaded != null && layersLoaded != undefined) {
				this.totalLoaded = this.totalLoaded + layersLoaded;
			} else {
				this.totalLoaded++;
			}

			console.log("TotalMapServices", this.totalLoaded + "/" + this.getTotalLayers());

			if (this.getTotalLayers() == this.totalLoaded)
			{
				if (layersIds != null && layersIds != undefined) {
					this.onUpdateFct(layersIds);
				}
				for ( var i = 0; i < this.loadList.length; i++)
				{
					this.loadList[i].remove();
				}
				this.mapstraction.loaded = true;

				console.log("spatialReference", this.map.spatialReference);

				// this is to store the map spatial reference to be
				// referenced by any other code
				window.mx = {
						esri: {
							sr: this.map.spatialReference
						}
				};
				var width = 0;
				if (this.map.extent)
				{
					width = this.map.extent.getWidth();
				}
				this.map._maximo = {
						mapStartingWidth: width,
						hasCachedMapService: this.hasCachedMapService
				};
				var ms = this.mapstraction;
				ms.state = {
						updating: false,
						panning: false,
						zooming: false
				};
				dojo.connect(this.map, "onUpdateStart", function(evt)
						{

					ms.state.updating = true;

						});
				dojo.connect(this.map, "onUpdateEnd", this, function(evt)
						{
					ms.state.updating = false;
					this.updateLegends(ms);
					// ms.endPan.fire();// no matching event

						});
				dojo.connect(this.map, "onPanStart", function(evt, startpoint)
						{
					ms.state.updating = true;

						});
				dojo.connect(this.map, "onPanEnd", function(evt)
						{
					ms.fireMapEvent(Events.endPan);
					ms.state.updating = false;

						});
				dojo.connect(this.map, "onZoomStart", function(extent, zoomFactor, anchor, level)
						{
					ms.state.updating = true;

						});

				dojo.connect(this.map, "onReposition", function(x, y)
						{
					dojo.publish("onESRIReposition");
						});
				dojo.connect(this.map, "onZoomEnd", function(extent, zoomFactor, anchor, level)
						{
					ms.state.updating = false;
					ms.fireMapEvent(Events.changeZoom);

						});
				if (this._failedLayers.length > 0)
				{
					console.warn("The following layers failed to load", this._failedLayers);
				}
				var fl = this._failedLayers;
				this.mapstraction.getFailedLayers = function()
				{
					return fl;
				};

				try
				{
					var scalebar = new Scalebar({
						map: this.map,
						scalebarUnit: this.lenUnit,
						attachTo: 'bottom-left'
					});
				}
				catch (e)
				{
					console.warn("failed to load scale bar");
					console.warn(e);
				}

				//TODO implement
//				if (!this.mapstraction.optParams.isMobile)
//				{
				try
				{
					var overviewMapDijit = new OverviewMap({
						map: this.map,
						color: "#6E6EFF",
						expandFactor: 2.5,
						maximizeButton: false,
						visible: false
					});
					overviewMapDijit.startup();
				}
				catch (e)
				{
					console.warn("failed to load Overview Map");
					console.warn(e);
				}
//				}

				var mapdivtooltipZoomInBtn = dijit.byId("mapdivtooltipZoomInBtn");
				if (mapdivtooltipZoomInBtn) {
					mapdivtooltipZoomInBtn.destroyRecursive(true);
				}
				var zoomInBtn = query("#mxmap_div-mapcontrol_mapdiv_zoom_slider .esriSimpleSliderIncrementButton");
				var delayTime = 500;
				if (this.mapConfig.provider = "spatial") {
					delayTime = this.mapConfig.tooltipDelayTime;
				}
				new Tooltip({
					id : "mapdivtooltipZoomInBtn",
					connectId : zoomInBtn,
					label : ibm.tivoli.fwm.i18n.getMaxMsg("map", "flyoverhelpzoomin"),
			        showDelay: delayTime
				});
				var mapdivtooltipZoomOutBtn = dijit.byId("mapdivtooltipZoomOutBtn");
				if (mapdivtooltipZoomOutBtn) {
					mapdivtooltipZoomOutBtn.destroyRecursive(true);
				}
				var zoomOutBtn = query("#mxmap_div-mapcontrol_mapdiv_zoom_slider .esriSimpleSliderDecrementButton");
				new Tooltip({
					id : "mapdivtooltipZoomOutBtn",
					connectId : zoomOutBtn,
					label : ibm.tivoli.fwm.i18n.getMaxMsg("map", "flyoverhelpzoomout"),
			        showDelay: delayTime
				});

				if (this.spatialConf.webMap && this.spatialConf.webMap.webMapDefined) {
					this.loadWebMapLayers(this.spatialConf);
				}
				this.mapstraction._loaded();
			} else {
				if (this.totalLoaded > this.getTotalLayers())
				{
					this.allLoaded = true;
				}
			}

		},
		updateLegends: function(ms)
		{
			// The ESRI legend component has a bug, the legend is not update automatically, so we need to force the refresh
			dojo.forEach(ms.layersManager.legends, function(legend)
					{
				legend.refresh();
					});

		},
		_failedLayers: [],
		/**
		 * when a map fails to load
		 */
		_failedToLoadMapService: function(args, error)
		{
			console.log("error", args, error);
			args.error = error;
			this._failedLayers.push(args);
			this.handleB4BaseMap(args, null);
			this.checkIfAllLoaded();
		},
		onUpdateFct: function(layerIds)
		{
			dojo.forEach(layerIds, function(layerId)
	    	{
	        	var layer = this.map.getLayer(layerId);
	        	if (this.fullExtent == null)
	    		{
	    			this.fullExtent = layer.fullExtent;
	    			console.info("this.fullExtent  ", this.fullExtent);
	    		}
	    		else
	    		{
	    			if (layer.fullExtent != null) {
	    				this.fullExtent = this.fullExtent.union(layer.fullExtent);
	    			} else {
	    				this.fullExtent = this.fullExtent.union(this.fullExtent);
	    			}

	    			console.info("this.fullExtent  ", this.fullExtent);
	    		}
	    	}, this);
	        this.checkIfAllLoaded();
		},
		hasCachedMapService: false,
		/**
		 * Determine the type of a layer and loads it
		 */
		determineTypeAndLoadLayer: function(response, mps, map)
		{

			var mapService;
			var featureLayersToAdd = {};
			var layersToAdd = [];
			var mapServiceParameter = {
					id: mps.name,
					opacity: parseFloat(mps.transparency),
					visible: mps.visible

			};
			
			var loadedToolsConfig = this.mapConfig.loadedToolsConfiguration;
			var spatialLayersLoaded = null;
			if (loadedToolsConfig != null) {
				var rootNodeSpatialLayers = loadedToolsConfig["SpatialLayersTool"];
				if (rootNodeSpatialLayers != null) {
					var customJson = rootNodeSpatialLayers.customJson;
					spatialLayersLoaded = customJson.layers[mps.name];
				}
			}

            var mapServiceUrl = mps.url;

       		mapServiceUrl = this.validateURL.addTokenIfApplicable(mapServiceUrl);

			if (response.tileInfo)
			{

				console.log(mps.name + ' is tiled ' + mps.url);
				if (spatialLayersLoaded != null) {
					mapServiceParameter.visible = spatialLayersLoaded.visible;
				}
				mapService = new esri.layers.ArcGISTiledMapServiceLayer(mapServiceUrl, mapServiceParameter);
				mapService.url = mps.url;

				this.hasCachedMapService = true;

			}
			else if (response.serviceDataType === "esriImageServiceDataTypeGeneric")
			{

				console.log(mps.label + ' is ImageServer service ' + mps.url);
				if (spatialLayersLoaded != null) {
					mapServiceParameter.visible = spatialLayersLoaded.visible;
				}
				var imageServiceParameters = new esri.layers.ImageServiceParameters();
				mapServiceParameter.imageParameters = imageServiceParameters;

				mapService = new esri.layers.ArcGISImageServiceLayer(mapServiceUrl, mapServiceParameter);
				mapService.url = mps.url;
				mapService.setDisableClientCaching(true);

			}
			else if (mps.url.toLowerCase().indexOf("mapserver") >= 0)
			{

				console.log(mps.name + ' is dynamic ' + mps.url);

				mapServiceParameter.visible = true;


				// Use the ImageParameters to set map service layer
				// definitions and map service visible layers before
				// adding to the client map.
				var imageParameters = new esri.layers.ImageParameters();

				imageParameters.transparent = true;

				if (this.mapInitialExtent)
				{

					console.log("has an extent", this.mapInitialExtent);

					imageParameters.bbox = this.mapInitialExtent;
				}
				mapServiceParameter.imageParameters = imageParameters;

				mapService = new esri.layers.ArcGISDynamicMapServiceLayer(mapServiceUrl, mapServiceParameter);
				mapService.url = mps.url;
				// for dynamic map services we don't cache its map
				// images locally bcuz changes to it are often.
				mapService.setDisableClientCaching(true);

				/*
				 * Determine layer visibility from ArcGIS
				 */
				let arcGISVisibleLayersIDs = [];
				for ( var i = 0; i < response.layers.length; i++) {
					if (response.layers[i].defaultVisibility == true) {
						arcGISVisibleLayersIDs.push(response.layers[i].id);
					}
					/*
					 * If layer visibility is FALSE AND has a parent, delete it from the array
					 */
					else if (response.layers[i].parentLayerId != -1) {
						const index = arcGISVisibleLayersIDs.indexOf(response.layers[i].parentLayerId);
						if (index !== -1) {
							arcGISVisibleLayersIDs.splice(index, 1);
						}
					}
				}

				mapService.setVisibleLayers(arcGISVisibleLayersIDs);

				if (spatialLayersLoaded != null) {
					mapService.setVisibleLayers(spatialLayersLoaded.visibleLayers);
					var databasePersistente = spatialLayersLoaded.sigoptions;
					if (databasePersistente != undefined){
						
						for (var j=0; j < mps.sigoptions.length; j++){
							var mapServiceSigoptions= mps.sigoptions[j];
							var addLayer = true;
							for (var i =0; i < databasePersistente.length; i++) {
								var databasePersistenteLine =  databasePersistente[i];
								if (mapServiceSigoptions.layerid == databasePersistenteLine.layerid && mapServiceSigoptions.active == databasePersistenteLine.active){
									addLayer = false;
								}
							}
							if (addLayer){
								mapService.visibleLayers.push(mapServiceSigoptions.layerid);					
							}
						}
					}
					
				} else {
					if (!mps.visible)
					{
						mapService.setVisibleLayers([-1]);
					}
				}
				if (mapService.sigoptions === undefined){
					mapService.sigoptions=mps.sigoptions;
				}

				// onload is triggered before we can execute actions
				// on the map
				dojo.connect(mapService, "onLoad", dojo.hitch(this, function(){
					console.log(mps.name + " layer was loaded waiting for 1st update");
					this.setSigoptionLayerandParentVisibilitytoFalse(mps, mapService);
					this.removerSigoptionLayersIDFromLayer(mps, mapService);
					dojo.publish("refreshMapTools", []); 
				}));

			} else {
				var fUrl;

				console.log(mps.name + " is a FeatureServer url: " + mps.url);

				mapServiceParameter.visible = true;
				var thisServiceFeatureLayers = [];
				for (var i = 0; i < response.layers.length; i++) {
					
					furl = mps.url+ "/" + response.layers[i].id;
	        		var featureLayerUrl = this.validateURL.addTokenIfApplicable(furl);

					mapServiceParameter.mode = FeatureLayer.MODE_ONDEMAND;
	            	mapServiceParameter.outFields = ["*"];
	            	mapServiceParameter.id = furl;

					console.log("new Feature Layer: " + featureLayerUrl);

					var layerToAdd = new FeatureLayer(featureLayerUrl, mapServiceParameter);
					layerToAdd.url = furl;
					thisServiceFeatureLayers.push(layerToAdd);
										
				}
				featureLayersToAdd.layers = thisServiceFeatureLayers;
				featureLayersToAdd.order = parseInt(mps.order) ;
			}
			// console.log("added layer ' " + mps.name + "' " + mps.order);
			// spatial order is the opposite, the biggest the order is the lower in
			// the map it will be
			console.log("order ", mps.order, this.basemapOrder);
			/*
			 * Add featureLayers
			 */
			if (featureLayersToAdd && featureLayersToAdd.layers && featureLayersToAdd.layers.length > 0) {
				if (this.baseMapAdded == true) {
					this.map.addLayers(featureLayersToAdd.layers);
					this.mapServicesLoaded ++;
				} else {
					for ( var id in featureLayersToAdd) {
						this.handleB4BaseMap(mps, featureLayersToAdd[id]);
					}
				}
			} 

			/*
			 * Add other types of layer
			 */
			if (mapService) {
				if (this.baseMapAdded == true) {
					var mapServiceIndex = this.getLayerIndex(parseInt(mps.order));
					
					if (mapServiceIndex !== -1) {
						this.map.addLayer(mapService, mapServiceIndex);
						this.updateMapLayerIndexes(parseInt(mps.order), mapServiceIndex);
					} else {
						this.map.addLayer(mapService);
					}
				} else {
					this.handleB4BaseMap(mps, mapService);
				}
			}
		},
		//If Sigoption enabled to Layer, need set visibility to false, to Layer and parent layer
		setSigoptionLayerandParentVisibilitytoFalse: function (mps, layer){
			
			var layerIdSigoptionParents = [];
			var layerIdSigoption = [];
			var newSigoptionVisibleLayer = [];
			
			if (layer.layerIdParentSigoptionDisabled === undefined){
				layer.layerIdParentSigoptionDisabled=[];
			}
			
			for (var i = 0; i < mps.sigoptions.length; i++) {
				var mpsSigoption = mps.sigoptions[i];
				if (mpsSigoption.active===false){
					layerIdSigoption.push(mpsSigoption.layerid);
					this.resetSigoptionLayerVisibility(layer, mpsSigoption.layerid, layerIdSigoptionParents);
				}
			}
			if (layer.visibleLayers != null){	
				
				newSigoptionVisibleLayer = layer.visibleLayers.filter(function(index){
				    return !(layerIdSigoptionParents.indexOf(index) >= 0 || layerIdSigoption.indexOf(index) >= 0);
				});
				console.log ("Parents need remove visibility",newSigoptionVisibleLayer);
				if (newSigoptionVisibleLayer.length > 0){
					layer.setVisibleLayers(newSigoptionVisibleLayer);
				}
				
			}
			
		},
		
		resetSigoptionLayerVisibility: function (layer, layerId, allParents){
		
			var position = this.getlayerInfosPosition(layer, layerId);	
			if (position !== null && layer.layerInfos[position].parentLayerId >=0 ){
				var layerInfosId  = layer.layerInfos[position].parentLayerId;
				allParents.push(layerInfosId);
				layer.layerIdParentSigoptionDisabled.push(layerInfosId);
				
				this.resetSigoptionLayerVisibility(layer, layerInfosId, allParents);
			}
		},
		
		getlayerInfosPosition: function (layer, layerId){
			
			var returnValue = null;
			for (var i = 0; i < layer.layerInfos.length; i++){
				var layerPosition = layer.layerInfos[i];
				if (layerPosition.id == layerId){
					return i;
				}
			} 
			
			return returnValue;
			
		},
		
		//If Sigoption Enabled and UserGroup don't have permission
		//remove layerid from layer.layerInfos.subLayerIds,layer.layerInfos
		//layer.visibleLayers, layer._defaultVisibleLayers.
		
		removerSigoptionLayersIDFromLayer: function (mps, layer){
			
			for (var i = 0; i < mps.sigoptions.length; i++){
				var sigoption = mps.sigoptions[i];
				var returnParent = [];
			
				for (var j = 0; j < layer.layerInfos.length; j++){
					var layerinfo = layer.layerInfos[j];
					
					//sublayerId
					if (layer.layerInfos[j].subLayerIds != null)
					{
						for (var k = 0; k < layer.layerInfos[j].subLayerIds.length; k++){
							if (layer.layerInfos[j].subLayerIds[k] == sigoption.layerid && sigoption.active === false){
								layer.layerInfos[j].subLayerIds.splice(k,1);
								break;			
							}
						}
					}
				
					if (layer.layerInfos[j].id == sigoption.layerid && sigoption.active === false){
						
						layer.layerInfos.splice(j,1);
						
						layer.visibleLayers = layer.visibleLayers.filter(function(line){
						    return line !== sigoption.layerid;
						 });
						
						layer._defaultVisibleLayers = layer._defaultVisibleLayers.filter(function(def){
							return def !== sigoption.layerid;
						});
						
						break;
					} 
												
				}

			}//for
		
		},
		handleB4BaseMap: function(mps, layer)
		{
			/*
			 * the basemap layer is added before the other layers. 
			 * the other layers are added to an array
			 */
			var layerOrder = parseInt(mps.order);
			if (layerOrder == this.basemapOrder)
			{
				this.baseMapAdded = true;
				if (layer)
				{
					if (this.messageDiv) {
						this.mapstraction.writeMessageInBox(this.messageDiv, "plussmap", "baseLayer", [layer.id]);
					}
					this.map.addLayer(layer);
					this.updateMapLayerIndexes(layerOrder, 0);
				}
				for ( var id in this.buffer)
				{
					var layerIndex = this.getLayerIndex(this.buffer[id].order);
					this.map.addLayer(this.buffer[id].layer, layerIndex);
					this.updateMapLayerIndexes(this.buffer[id].order, layerIndex);
				}
				for ( var id in this.featureLayerBuffer)
				{
					if (this.featureLayerBuffer[id].layers && this.featureLayerBuffer[id].layers.length > 0) {
						this.map.addLayer(this.featureLayerBuffer[id].layers);
					}
					this.mapServicesLoaded++;
				}
			} else
			{
				if (layer)
				{
					if (layer instanceof FeatureLayer)
					{
						this.featureLayerBuffer.push(layer);
					} else {
						this.buffer.push({"layer": layer, "order": layerOrder});
					}
				}

			}
		},
		buffer: [],
		featureLayerBuffer: [],
		numberOfBaseMaps: 0,
		/**
		 * returns the total number of layers to be loaded
		 */
		getTotalLayers: function()
		{
			return this.totalMapServices + this.numberOfExternalMaps;
		},
		/**
		 * Create a OpenStreetMap Layer
		 */
		createOSMLater: function()
		{

			try
			{
				if (this.osmTries == 0)
				{
					this.numberOfExternalMaps++;
				}
				this.openStreetMapLayer = new esri.layers.OpenStreetMapLayer();
				/*
				 * esri.layers.OpenStreetMapLayer( { id: "OpenStreetMap", visible:
				 * true, opacity: 1, displayLevels:[0,1,2] });
				 */

				this.map.addLayer(this.openStreetMapLayer, 0);
				this.baseMapAdded = true;
				this.mapServicesLoaded ++;
				this.loadList.push(dojo.connect(this.openStreetMapLayer, "onUpdate", dojo.hitch(this, "checkIfAllLoaded")));
				// for all maps loaded event
			}
			catch (e)
			{
				console.log("osm", e);
				if (this.osmTries < 6)
				{
					this.osmTries++;
					console.warn('postpone OSM');
					setTimeout(dojo.hitch(this, this.createOSMLater), 500);
				}
				else
				{
					console.error('failed to load OSM');
				}
			}

		},
		/**
		 * Create a bing map layer
		 */
		createBingMapsLayer: function(key)
		{
			this.numberOfExternalMaps++;
			this.bingMapsLayer = new esri.virtualearth.VETiledLayer({
				id: "Bing Maps",
				bingMapsKey: key,
				mapStyle: esri.virtualearth.VETiledLayer.MAP_STYLE_ROAD
			});
			this.mapServicesLoaded ++;
			this.map.addLayer(this.bingMapsLayer);
			this.baseMapAdded = true;
			this.loadList.push(dojo.connect(this.bingMapsLayer, "onUpdateEnd", dojo.hitch(this, this.checkIfAllLoaded)));

			var bingMapsButtonsDiv = dojo.create('div', {
				id: 'bingButtons',
				className: 'bingMapsButtonsDiv'
			}, dojo.byId(this.map.id));

			var buttonClick = dojo.hitch(this, function(id)
					{
				this.bingMapsLayer.setMapStyle(id);
					});

			var msg1 = ibm.tivoli.fwm.i18n.getMaxMsg("plussmap", "bing_button_aerial");
			var aerials = dojo.create('button', {
				innerHTML: msg1
			}, bingMapsButtonsDiv);
			dojo.connect(aerials, 'onclick', null, function()
					{
				buttonClick(esri.virtualearth.VETiledLayer.MAP_STYLE_AERIAL);
					});

			var msg2 = ibm.tivoli.fwm.i18n.getMaxMsg("plussmap", "bing_button_aerialwithlabels");
			var aerialsWithLegend = dojo.create('button', {
				innerHTML: msg2
			}, bingMapsButtonsDiv);
			dojo.connect(aerialsWithLegend, 'onclick', null, function()
					{
				buttonClick(esri.virtualearth.VETiledLayer.MAP_STYLE_AERIAL_WITH_LABELS);
					});

			var msg3 = ibm.tivoli.fwm.i18n.getMaxMsg("plussmap", "bing_button_roads");
			var roads = dojo.create('button', {
				innerHTML: msg3
			}, bingMapsButtonsDiv);
			dojo.connect(roads, 'onclick', null, function()
					{
				buttonClick(esri.virtualearth.VETiledLayer.MAP_STYLE_ROAD);
					});

		},
		loadWebMapLayers: function(spatialConf) {
			if (spatialConf.webMap.webMapDefined) {
				var webMapLayers = [];

				dojo.connect(this.map, "onLayersAddResult", this, function(layers){
					var webMapLayersLoaded = 0;
					 dojo.forEach(layers, function(obj){
						 	if (obj.layer.isWebMap) {
						 		if (obj.layer.tileInfo) {
							 		var index = null;
							 		dojo.forEach(this.map.layerIds, function(layerId, i){
									 	var layer = this.map.getLayer(layerId);
									 	if (layer.tileInfo && index == null) {
									 		index = i;
									 	}
									}, this);
							 		this.map.reorderLayer(obj.layer,(index+1));
							 	}
							 	var markerLayer = this.map.getLayer("providerMarkerLayer");
							 	if (markerLayer) {
							 		this.map.reorderLayer(markerLayer,this.map.layerIds.length+1);
							 	}
							 	webMapLayersLoaded++;
						 	}

						}, this);
					 if(webMapLayersLoaded == webMapLayers.length) {
						 dojo.publish("startupToolbarMapInit",[]);
					 }

				 });

				var aDeferreds = [];
				var response = this.map.webMapResponse;

				dojo.forEach(response.itemInfo.itemData.operationalLayers, function(layer){
					webMapLayers.push(layer)
				}, this);

				var thisObj = this;
				var preCallBack = function(ioArgs) {
				    // don't forget to return ioArgs.
				    return ioArgs;
				}
				esriRequest.setRequestPreCallback(preCallBack);
				
				if (webMapLayers.length == 0) {
					dojo.publish("startupToolbarMapInit",[]);
				} 

				dojo.forEach(webMapLayers, function(layer){
					var tokenUrlIfNeeded = this.validateURL.addTokenIfApplicable(layer.url);
					var request = esriRequest({
			            "url": tokenUrlIfNeeded, // layer.url,
			            "content": {
			              "f": "json"
			            },
			            "callbackParamName": "callback"
			          });
					aDeferreds.push(request);
				}, this);
				promises = all(aDeferreds);
				promises.then(lang.hitch(this, function(responseLayers) {
					layersToAdd = [];
					dojo.forEach(responseLayers, lang.hitch(this, function(responseLayer, i){
						var opeLayer = webMapLayers[i];
						var layerExist = this.map.getLayer(opeLayer.url);
						if (!layerExist) {
							var layer = this.createNewLayer(responseLayer, webMapLayers[i]);
							layer.isWebMap = true
							layersToAdd.push(layer);
						}
					}));
					this.map.addLayers(layersToAdd);
				}), lang.hitch(this, function(err) {
					console.error('******** error', err);
				}));
			}
		},
		createNewLayer: function(response, mps) {
			var layer;
			var mapServiceParameter = {
					id: mps.title,
					opacity: parseFloat(mps.opacity),
					visible: mps.visibility
			};


            var mapServiceUrl = mps.url;
        	mapServiceUrl = this.validateURL.addTokenIfApplicable(mapServiceUrl);

            if (mps.layerType=="ArcGISFeatureLayer") {
            	console.log(mps.title + ' is Feature Layer ' + mps.url);
            	mapServiceParameter.mode = FeatureLayer.MODE_ONDEMAND;
            	mapServiceParameter.outFields = ["*"];
            	layer = new FeatureLayer(mapServiceUrl, mapServiceParameter);
            	layer.url = mps.url;
            	layer._plussLayerId = response.id;

			}
            else if (response.tileInfo)
			{
            	mapServiceParameter.id = mps.id;
				console.log(mps.id + ' is tiled ' + mps.url);

				layer = new esri.layers.ArcGISTiledMapServiceLayer(mapServiceUrl, mapServiceParameter);
            	layer.url = mps.url;

			}
			else if (response.serviceDataType === "esriImageServiceDataTypeGeneric")
			{

				console.log(mps.id + ' is ImageServer service ' + mps.url);

				var imageServiceParameters = new esri.layers.ImageServiceParameters();
				mapServiceParameter.imageParameters = imageServiceParameters;

				layer = new esri.layers.ArcGISImageServiceLayer(mapServiceUrl, mapServiceParameter);
            	layer.url = mps.url;
				layer.setDisableClientCaching(true);	
			}
			else
			{

				console.log(mps.id + ' is dynamic ' + mps.url);

				mapServiceParameter.visible = true;


				// Use the ImageParameters to set map service layer
				// definitions and map service visible layers before
				// adding to the client map.
				var imageParameters = new esri.layers.ImageParameters();

				imageParameters.transparent = true;

				if (mps.visibleLayers && mps.visibleLayers.length > 0 && mps.visibleLayers[0] !== 'all')
				{
					// I want layers 5,4, and 3 to be visible
					imageParameters.layerIds = mps.visibleLayers;
					imageParameters.layerOption = esri.layers.ImageParameters.LAYER_OPTION_SHOW;

				}

				mapServiceParameter.imageParameters = imageParameters;
				//

				layer = new esri.layers.ArcGISDynamicMapServiceLayer(mapServiceUrl, mapServiceParameter);
            	layer.url = mps.url;

				// for dynamic map services we don't cache its map
				// images locally bcuz changes to it are often.
				layer.setDisableClientCaching(true);
				if (!mps.visible)
				{
					layer.setVisibleLayers([-1]);
				}
			}
			return layer;
		},
		getMaxOrderConfigured: function(spatialConf) {
			var maxOrder = -1;
			dojo.forEach(spatialConf.mapservices, function(mapservice)
			{
				var mapServiceOrder = parseInt(mapservice.order);
				if (mapServiceOrder > maxOrder) {
					maxOrder = mapServiceOrder;
				}
			}, this);
			return maxOrder;
		},
		loadMapServiceLayers: function (spatialConf) {

			this._failedLayers = [];
			this.layersAlreadyAddedIndex = [];
			this.featureLayersAddedIndex = [];
			this.mapServicesLoaded = 0;
			// Bing Maps layer
			if (spatialConf.bingMaps)
			{
				this.createBingMapsLayer(spatialConf.bingMapsKey);
			}
			// OpenStreetMap layer
			if (spatialConf.openStreetMap)
			{
				this.createOSMLater();
			}

			this.totalLoaded = 0;
			if (spatialConf.webMap.webMapDefined) {
				var maxOrder = this.getMaxOrderConfigured(spatialConf);
				if (this.map.webMapResponse.itemInfo.itemData.baseMap) {
					dojo.forEach(this.map.webMapResponse.itemInfo.itemData.baseMap.baseMapLayers, function(baseMapLayer)
					{
						maxOrder++;
						var newBaseMap = {
								id: baseMapLayer.id,
								name: baseMapLayer.id,
								order: maxOrder,
								transparency: parseFloat(baseMapLayer.opacity),
								url: baseMapLayer.url,
								visible: baseMapLayer.visibility,
								visibleLayers: ['all']
						};
						this.basemapOrder = maxOrder;
						spatialConf.mapservices.push(newBaseMap);
					}, this);
				}
			}

			if (!this.basemapOrder && spatialConf.mapservices[0])
			{
				this.basemapOrder = parseInt(spatialConf.mapservices[0].order);
			}

			var thisObj = this;
			var preCallBack = function(ioArgs) {
				
				/**
				 * When the request comes from Route we do not need to verify the token since
				 * it was already created.
				 */
				if (ioArgs.url != null && ioArgs.url.indexOf("/plusstokenstart/") > -1) {
					return ioArgs;
				}
				
				if (ioArgs.url != null && ioArgs.url.indexOf("token=") == -1)
				{
					ioArgs.url = thisObj.validateURL.addTokenIfApplicable(ioArgs.url);
				}

			    if (ioArgs.content != null && ioArgs.content.token != null) {
			    	ioArgs.content.token = null;
			    }

			    // don't forget to return ioArgs.
			    return ioArgs;
			}
			esriRequest.setRequestPreCallback(preCallBack);
			
			this.mapServicesOrder = dojo.map(spatialConf.mapservices, function(mapService) {
				return parseInt(mapService.order);
			});
			
			//If there is a OpenStreetMap, it will be placed first on the map
			if (spatialConf.openStreetMap) {
				if (this.basemapOrder) {
					this.basemapOrder = parseInt(this.basemapOrder)+1;
					//this.mapServicesOrder.unshift(this.basemapOrder);
					this.layersAlreadyAddedIndex.push(this.basemapOrder);
				}
			}
			//If there is a Bing Map, it will be added to the Map before the Map Service Layers 
			if (spatialConf.bingMaps) {
				if (this.basemapOrder) {
					this.basemapOrder = parseInt(this.basemapOrder)+1;
					//this.mapServicesOrder.unshift(this.basemapOrder);
					this.layersAlreadyAddedIndex.push(this.basemapOrder);
				}
			}

			
			//if (this.basemapOrder && this.messageDiv && !this.baseMapAdded) {
			//	this.mapstraction.writeMessageInBox(this.messageDiv, "plussmap", "baseMapOrder", [this.basemapOrder] );
			//}
			
			//Sort the MapServicesOrder, in case a web Map baseMap was added
			function sortIntegerDec(a,b) {
			    return b - a;
			}
			this.mapServicesOrder.sort(sortIntegerDec);

			for ( var svcId = 0; svcId < spatialConf.mapservices.length; svcId++)
			{

				var mapServiceInfo = spatialConf.mapservices[svcId];

				if (!mapServiceInfo.webmapdefined) {

					// Ignore invisible map services because they will not fire the expected
					// onUpdate event
					//	if(mapServiceInfo.visible == true) {

					var rParams = {
							"f": "json"
					};

					console.log(this.totalMapServices + " " + svcId + " " + spatialConf.mapservices[svcId].order, spatialConf.mapservices[svcId]);
					this.totalMapServices++;
					this.addCorsEnabledServers(mapServiceInfo.url);

		            var mapServiceUrl = mapServiceInfo.url;

//		        	mapServiceUrl = this.validateURL.addTokenIfApplicable(mapServiceUrl);

		            this.loadList.push(this.map.on("update-end", dojo.hitch(this, function (args) {
		            	this.checkIfAllLoaded(null, args.target.layerIds);
		            })));

		            this._arcGISMapResizeUpdate();
		            
		            var layerRequest = esri.request({
						url: mapServiceUrl,
						load: dojo.hitch(this, function(arg, arg2) {
							this.determineTypeAndLoadLayer(arg, arg2.args.params.mapServiceInfo, this.map);
						}),
						error: dojo.hitch(this, function(error) {
							this._failedToLoadMapService(mapServiceInfo, error);
						}),
						handleAs: "json",
						callbackParamName: "callback",
						async: false,
						content: rParams,
						params: {
							"mapServiceInfo": mapServiceInfo
						},
						timeout: 30000
					});
				}
			}
		},
		
		_arcGISMapResizeUpdate: function () { // help minimize number of request to arcGIS server

			aspect.after(window, "sizePanes", lang.hitch(this,this._mapResize));
			
            this.map.on("resize",  dojo.hitch(this, function (args) {
    			if ( dojo.config.fwm.debug == true ){
    				console.log("MaximoSpatialMxn - resized width: " + args.width + " Height: " + args.height);
    			}
            	
				this._mapResize();
            }));
        
            var me = this;			            
			var loadImg = dojo.create("img", {"style":"position:absolute; left:0px; top:0px; ","class":"", "src": dojo.config.fwm.ctxRoot + "/webclient/images/pluss/loading_spatial.gif"});
			dojo.place(loadImg, dojo.byId(this.map.id), "last");
			esri.hide(loadImg);
			this.map._loadImg = loadImg;

            this.map.on("update-end",  dojo.hitch(this, function (args) {
    			if ( dojo.config.fwm.debug == true ) {
            		console.log("MaximoSpatialMxn - update-end");
            	}
            	
				this._mapResize();
            }));            
		},
		
		savedWidth: "0",
		
		_mapResize: function () {
			var systemNavAppContent = dojo.byId( "SystemNavAppContent-sc_div" );
            if (systemNavAppContent != null && systemNavAppContent.style != null) {
            	if ( dojo.config.fwm.debug == true ) {
					console.log("SystemNavAppContent-sc_div width: " + systemNavAppContent.style.width);
            	}
				var width = parseInt(systemNavAppContent.style.width.split("px")[0]);
				var widthAdj = (parseInt(width * .96)).toString() + "px";
				var widthRootAdj = widthAdj;
				
				if (!width) {
					width = document.getElementById('SystemNavAppContent-sc_div').clientWidth;
					widthAdj = (parseInt(width * .96)).toString() + "px";
					widthRootAdj = widthAdj;
				}
				
				if ( width >= window.innerWidth) {
					widthAdj = (parseInt(window.innerWidth * .96)).toString() + "px";
					widthRootAdj = widthAdj;
				} else if (width == this.savedWidth) {
					widthAdj = "99%";
					widthRootAdj = "100%";
				}

				this.savedWidth = width;
				
    			var mapCtrl = dojo.byId( "mxmap_div-mapcontrol_mapdiv" );
    			var mapCtrlTB = dojo.byId( "mxmap_div-mapcontrol_mapdiv_toolbar" );

    			if (mapCtrl != null && mapCtrlTB != null) {
					dojo.style("mxmap_div-mapcontrol_mapdiv_toolbar", {"width": widthAdj});
					dojo.style("mxmap_div-mapcontrol_mapdiv", {"width": widthAdj});
					dojo.style("mxmap_div-mapcontrol_mapdiv_root", {"width": widthRootAdj});
    			}
            }	
		},
		
		/**
		 * Loads a map based on a map configuration
		 */
		loadMap: function(spatialConf)
		{
			this.spatialConf = spatialConf;
			this.loadMapServiceLayers(spatialConf);
		},
		
		createLinearLayers: function(measureUnits) {
			var linearLayers = this.mapConfig.maplinearConf.maplinearLayers;
			var newGraphicsLayers = [];
			for (var key in linearLayers) {
			    if (!linearLayers.hasOwnProperty(key)) continue;
			    var linearLayerAttrs = linearLayers[key];
			    //Create graphics
			    var linearLayer = new GraphicsLayer({
					id : linearLayerAttrs["LAYERNAME"]
				});
			    linearLayer.isLinear = true;
			    linearLayer.linearConfig = linearLayerAttrs;
			    linearLayer.layerAttributes = {};
			    linearLayer.layerAttributes.displayField = "GRAPHICID";
			    newGraphicsLayers.push(linearLayer);
			}
			arrayUtils.forEach(newGraphicsLayers, lang.hitch(this, function(newGraphicsLayer, i){
				var layerExist = this.map.getLayer(newGraphicsLayer.id);
				if (layerExist) {
					this.map.removeLayer(layerExist);
				}
			}));
			if (dojo.config.fwm.debug == true)
			{
				console.log("[Linear] Loading layers ", newGraphicsLayers);
			}
			this.linear.clearLinearGraphics();
			if (this.linearOnMouseOverEvents.length > 0) {
				arrayUtils.forEach(this.linearOnMouseOverEvents, lang.hitch(this, function(mouveOverEvent, j){
					dojo.disconnect(mouveOverEvent);
				}));
				this.linearOnMouseOverEvents = [];
			}
			if (this.linearOnMouseOutEvents.length > 0) {
				arrayUtils.forEach(this.linearOnMouseOutEvents, lang.hitch(this, function(mouveOutEvent, j){
					dojo.disconnect(mouveOutEvent);
				}));
				this.linearOnMouseOutEvents = [];
			}

			if (newGraphicsLayers.length > 0) {
				var addLinearLayerEvent = this.map.on("layers-add-result", lang.hitch(this, function(param) {

					addLinearLayerEvent.remove();
					var webMapDefined = this.mapConfig.SPATIAL.webMap && this.mapConfig.SPATIAL.webMap.webMapDefined;
					if (webMapDefined == false) {
						dojo.publish("startupToolbarMapInit",[]);
					}
					var initialTime = new Date().getTime();
					arrayUtils.forEach(param.layers, lang.hitch(this, function(layerAdded, i){
						var layer = layerAdded.layer;
						layer.sequenceId = i;
						this.drawMeasuresOnLayer(layer, false, i, measureUnits);
					 }));
					var finalTime = new Date().getTime();
					if (dojo.config.fwm.debug == true)
					{
						console.log("[LINEAR] Graphics created, number of graphics: ", this.linear.linearGraphics.totalGraphics);
						console.log("[LINEAR] Graphics created, total time (ms): ", finalTime-initialTime);
					}
					var markerLayer = this.map.getLayer("providerMarkerLayer");
					var graphicLayersLength = this.map.graphicsLayerIds.length;
					if (markerLayer && graphicLayersLength>0) {
						
						this.map.reorderLayer(markerLayer, graphicLayersLength-1);
					}
					
					dojo.publish("refreshMapTools", []);
				}));

				this.map.addLayers(newGraphicsLayers);
			}
		},
		
		createLinearTargetLayer: function(measureUnits) {
			var linearTargetAttrs = this.mapConfig.maplinearConf.linearObjTarget;
			    var linearTargetLayer = new GraphicsLayer({
					id : "lvcTargetMapLayer"
				});
			    
		    linearTargetLayer.linearConfig = linearTargetAttrs;
		    linearTargetLayer.layerAttributes = {};
		    linearTargetLayer.layerAttributes.displayField = "GRAPHICID";
		    
			var layerExist = this.map.getLayer(linearTargetLayer.id);
			if (layerExist) {
				this.map.removeLayer(layerExist);
			}
			
			if (dojo.config.fwm.debug == true) {
				console.log("[Linear] Loading target layer ", linearTargetLayer.id);
			}
			
			if (this.linearOnMouseOverEvents.length > 0) {
				arrayUtils.forEach(this.linearOnMouseOverEvents, lang.hitch(this, function(mouveOverEvent, j){
					dojo.disconnect(mouveOverEvent);
				}));
				this.linearOnMouseOverEvents = [];
			}
			
			if (this.linearOnMouseOutEvents.length > 0) {
				arrayUtils.forEach(this.linearOnMouseOutEvents, lang.hitch(this, function(mouveOutEvent, j){
					dojo.disconnect(mouveOutEvent);
				}));
				this.linearOnMouseOutEvents = [];
			}

			this.drawMeasuresOnTarget(linearTargetLayer, false, measureUnits);
				
			dojo.publish("refreshMapTools", []);

			this.map.addLayer(linearTargetLayer);
		},
		
		drawMeasuresOnTarget: function(layer, layerExist, measureUnits) {
			var colorArray = this.linear.colorArray;
			if (layerExist) {
				layer.clear();
			}
			this.linear.setMeasureUnits(measureUnits);
			var initialDistanceParameter = layer.linearConfig["calculatedStartMeasure"];
		    var distanceParameter = Number(layer.linearConfig["calculatedEndMeasure"]) - Number(initialDistanceParameter);
		    var id = layer.linearConfig["id"];
		    layer.linearConfig.mapConfig = this.mapConfig;
		    if (this.mapConfig.currentMbo.FC) {
		    	this.linear.createTargetGraphics(this.mapConfig.currentMbo.FC.geometry.paths,
		  			initialDistanceParameter, distanceParameter, id, layer, this.map);
		    } else {
		    	this.linear.createTargetGraphics(this.mapConfig.currentMbo.autolocate.FC.geometry.paths,
  			  		initialDistanceParameter, distanceParameter, id, layer, this.map);
		    }
			var linearOnMouseOver = dojo.connect(layer, "onMouseOver", lang.hitch(this, function(evt) {
				var g = evt.graphic;
				this.linear.enableHighlight(g);
			}));
			this.linearOnMouseOverEvents.push(linearOnMouseOver);
			var linearOnMouseOut = dojo.connect(layer, "onMouseOut", lang.hitch(this, function(evt) {
				var g = evt.graphic;
				setTimeout(lang.hitch(this, function(){
					this.linear.disableHighlight(g);
				}), 1000);
			}));
			this.linearOnMouseOutEvents.push(linearOnMouseOut);
		},
		
		loadLinearLayers: function(me, mapMeasureUnit) {
			var refreshEntireMapRunning = me._refreshEntireMapRunning;
			var maximo = me.getMaximo();
			this.linear.symbologyManager = me.getSymbologyManager();
			var maximoMapMeasureUnit = "";
			this.linear.clearLinearGraphics();
			console.info("loadLinearLayers map Unit  ", mapMeasureUnit);
			switch(mapMeasureUnit) {
				case "esriMeters":
			        maximoMapMeasureUnit = "METER";
			        break;
				case "esriMiles":
			        maximoMapMeasureUnit = "MILES";
			        break;
				case "esriKilometers":
			        maximoMapMeasureUnit = "KM";
			        break;
				case "esriCentimeters":
			        maximoMapMeasureUnit = "CM";
			        break;
				case "esriMillimeters":
			        maximoMapMeasureUnit = "MM";
			        break;
				case "esriFeet":
			        maximoMapMeasureUnit = "FEET";
			        break;
				case "esriInches":
			        maximoMapMeasureUnit = "INCHES";
			        break;
			    default:
			    	maximoMapMeasureUnit = mapMeasureUnit;
			} 
				maximo.refreshLinearLayers(maximoMapMeasureUnit, lang.hitch(this, function(ok){
					if (ok.result == "fail") {
						maximo.showMessage("mapcontrol", "errorCreatingLinearLayer", [ok.errorMessage]);
					} else {
						this.mapConfig.maplinearConf = ok.maplinearConf;
						this.createLinearLayers(maximoMapMeasureUnit);
						if (this.mapConfig.maplinearConf.linearObjTarget != null) {
							this.createLinearTargetLayer(maximoMapMeasureUnit);
						}
					}
				}),lang.hitch(this, function(error){
					var error = {
							message: "Error refreshing Linear Layers",
							msggroup: "mapcontrol",
							msgkey: "errorCreatingLinearLayer"
					};
					errCallback(error);
				}));
		},
		drawMeasuresOnLayer: function(layer, layerExist, i, measureUnits) {
			var colorArray = this.linear.colorArray;
			if (layerExist) {
				layer.clear();
			}
			this.linear.setMeasureUnits(measureUnits);
			arrayUtils.forEach(layer.linearConfig["MEASURES"], lang.hitch(this, function(distanceParam, j){
				var initialDistanceParameter = distanceParam["STARTMEASURE"];
  			    var distanceParameter = Number(distanceParam["ENDMEASURE"]) - Number(initialDistanceParameter);
  			    var id = Number(distanceParam["ID"]);
  			    layer.linearConfig.mapConfig = this.mapConfig;
  			    if (this.mapConfig.currentMbo.FC) {
  			    	this.linear.createGraphics(this.mapConfig.currentMbo.FC.geometry.paths,
  			  			initialDistanceParameter, distanceParameter, id, layer, layer.linearConfig, distanceParam);
  			    } else {
  			    	this.linear.createGraphics(this.mapConfig.currentMbo.autolocate.FC.geometry.paths,
  	  			  		initialDistanceParameter, distanceParameter, id, layer, layer.linearConfig, distanceParam);
  			    }
  			 }));
			var linearOnMouseOver = dojo.connect(layer, "onMouseOver", lang.hitch(this, function(evt) {
				var g = evt.graphic;
				this.linear.enableHighlight(g);
			}));
			this.linearOnMouseOverEvents.push(linearOnMouseOver);
			var linearOnMouseOut = dojo.connect(layer, "onMouseOut", lang.hitch(this, function(evt) {
				var g = evt.graphic;
				setTimeout(lang.hitch(this, function(){
					this.linear.disableHighlight(g);
				}), 1000);
			}));
			this.linearOnMouseOutEvents.push(linearOnMouseOut);
		},
		addCorsEnabledServers: function(url)
		{
			if(esriConfig.defaults.io.corsEnabledServers.indexOf(url) == -1)
			{
				esriConfig.defaults.io.corsEnabledServers.push({
					  host: url,
					  withCredentials: true
					});
			}
		},
		isPointInFullExtent: function(pt)
		{
			var fullextent = this.map.extent;

			if (this.fullExtent)
			{
				fullextent = this.fullExtent;
			}
			return fullextent.contains(pt);
		},
		toWebMercatorCache: {},
		projectPointsToWebMercator: function(points, callbackFct, errCallback)
		{

			var outSR = new esri.SpatialReference({
				wkid: 4326
			});
			var esriPoints = [];
			var propPoints = [];

			for ( var i = 0; i < points.length; i++)
			{
				if (this.toWebMercatorCache[points[i]] != null)
				{
					propPoints.push(this.toWebMercatorCache[points[i]]);
					continue;
				}
				esriPoints.push(points[i].toProprietary("maximospatial"));
			}

			if (propPoints.length == points.length)
			{

				callbackFct(propPoints);
				return;
			}
			if (this.esriGeometryService == null)
			{
				var error = {
						message: "Geometry service not found",
						msggroup: "plussmap",
						msgkey: "failed_loading_geometry_service"
				};
				errCallback(error);
			}
			var mxnMe = this.mapstraction;
			this.esriGeometryService.project(esriPoints, outSR, function(projectedPoints)
					{

				for ( var i = 0; i < projectedPoints.length; i++)
				{
					var esriP = projectedPoints[i];
					var pp = mxnMe.latLng(esriP.y, esriP.x, outSR.wkid);
					mxnMe.toWebMercatorCache[points[i]] = pp;
					propPoints.push(pp);
				}

				callbackFct(propPoints);
					});

		},
		fromWebMercatorCache: {},
		projectPointsFromWebMercator: function(points, callbackFct, errCallback)
		{
			var outSR = window.mx.esri.sr;
			var esriPoints = [];
			var mercatorSr = new esri.SpatialReference({
				wkid: 4326
			});
			var propPoints = [];

			for ( var i = 0; i < points.length; i++)
			{
				if (this.fromWebMercatorCache[points[i]] != null)
				{
					propPoints.push(this.fromWebMercatorCache[points[i]]);
					continue;
				}
				var p = new esri.geometry.Point(points[i].lng, points[i].lat, mercatorSr);
				esriPoints.push(p);
			}

			if (propPoints.length == points.length)
			{

				callbackFct(propPoints);
				return;
			}
			if (this.esriGeometryService == null)
			{
				var error = {
						message: "Geometry service not found",
						msggroup: "plussmap",
						msgkey: "failed_loading_geometry_service"
				};
				errCallback(error);
			}
			var mxnMe = this.mapstraction;
			this.esriGeometryService.project(esriPoints, outSR, function(projectedPoints)
					{

				for ( var i = 0; i < projectedPoints.length; i++)
				{
					var esriP = projectedPoints[i];

					var pp = mxnMe.latLng(esriP.y, esriP.x, outSR.wkid);
					mxnMe.fromWebMercatorCache[points[i]] = pp;
					propPoints.push(pp);
				}

				callbackFct(propPoints);
					});
		},
		getLayerIndex: function(layerOrder) {
			var layerIndex;
			var k=0;
			while (layerIndex == null && k < this.layersAlreadyAddedIndex.length) {
				if (layerOrder > this.layersAlreadyAddedIndex[k]) {
					layerIndex = k;
				}
				k++;
			}
			if (layerIndex == null) {
				layerIndex = this.layersAlreadyAddedIndex.length;
			}
			return layerIndex;
		},
		updateMapLayerIndexes: function(order, index) {
			this.layersAlreadyAddedIndex.splice(index, 0, order);
		}
	});
});